Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 c3754a5b 2019-05-10 stsp
27 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
28 7b67836a 2019-05-10 stsp
29 f6cae3ed 2020-09-13 naddy git_init()
30 0e673013 2019-01-02 stsp {
31 0b2899f8 2019-08-18 stsp git init -q "$1"
32 0e673013 2019-01-02 stsp }
33 0e673013 2019-01-02 stsp
34 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
35 b32c4525 2020-01-05 stsp {
36 b32c4525 2020-01-05 stsp local repo="$1"
37 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
38 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
39 b32c4525 2020-01-05 stsp fi
40 b32c4525 2020-01-05 stsp }
41 b32c4525 2020-01-05 stsp
42 f6cae3ed 2020-09-13 naddy git_commit()
43 0e673013 2019-01-02 stsp {
44 0e673013 2019-01-02 stsp local repo="$1"
45 0e673013 2019-01-02 stsp shift
46 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
47 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
48 0e673013 2019-01-02 stsp }
49 0e673013 2019-01-02 stsp
50 f6cae3ed 2020-09-13 naddy git_rm()
51 512f0d0e 2019-01-02 stsp {
52 512f0d0e 2019-01-02 stsp local repo="$1"
53 512f0d0e 2019-01-02 stsp shift
54 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
55 512f0d0e 2019-01-02 stsp }
56 512f0d0e 2019-01-02 stsp
57 f6cae3ed 2020-09-13 naddy git_show_head()
58 9c4b8182 2019-01-02 stsp {
59 9c4b8182 2019-01-02 stsp local repo="$1"
60 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
61 9c4b8182 2019-01-02 stsp }
62 9c4b8182 2019-01-02 stsp
63 f6cae3ed 2020-09-13 naddy git_show_branch_head()
64 db32465d 2020-02-07 stsp {
65 db32465d 2020-02-07 stsp local repo="$1"
66 db32465d 2020-02-07 stsp local branch="$2"
67 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
68 db32465d 2020-02-07 stsp }
69 db32465d 2020-02-07 stsp
70 db32465d 2020-02-07 stsp
71 f6cae3ed 2020-09-13 naddy git_show_author_time()
72 bcb49d15 2019-08-14 stsp {
73 bcb49d15 2019-08-14 stsp local repo="$1"
74 01073a5d 2019-08-22 stsp local object="$2"
75 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
76 bcb49d15 2019-08-14 stsp }
77 bcb49d15 2019-08-14 stsp
78 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
79 8e7bd50a 2019-08-22 stsp {
80 8e7bd50a 2019-08-22 stsp local repo="$1"
81 8e7bd50a 2019-08-22 stsp local tag="$2"
82 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
83 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
84 8e7bd50a 2019-08-22 stsp }
85 8e7bd50a 2019-08-22 stsp
86 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
87 818c7501 2019-07-11 stsp {
88 818c7501 2019-07-11 stsp local repo="$1"
89 70551d57 2020-04-24 stsp local commit="$2"
90 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
91 818c7501 2019-07-11 stsp }
92 818c7501 2019-07-11 stsp
93 f6cae3ed 2020-09-13 naddy git_show_tree()
94 03415a1a 2019-06-02 stsp {
95 03415a1a 2019-06-02 stsp local repo="$1"
96 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
97 03415a1a 2019-06-02 stsp }
98 03415a1a 2019-06-02 stsp
99 f6cae3ed 2020-09-13 naddy trim_obj_id()
100 818c7501 2019-07-11 stsp {
101 9439a990 2020-09-16 naddy local trimcount=$1
102 9439a990 2020-09-16 naddy local id=$2
103 818c7501 2019-07-11 stsp
104 9439a990 2020-09-16 naddy local pat=""
105 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
106 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
107 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
108 818c7501 2019-07-11 stsp done
109 818c7501 2019-07-11 stsp
110 818c7501 2019-07-11 stsp echo ${id%$pat}
111 818c7501 2019-07-11 stsp }
112 818c7501 2019-07-11 stsp
113 f6cae3ed 2020-09-13 naddy git_commit_tree()
114 03415a1a 2019-06-02 stsp {
115 03415a1a 2019-06-02 stsp local repo="$1"
116 03415a1a 2019-06-02 stsp local msg="$2"
117 03415a1a 2019-06-02 stsp local tree="$3"
118 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
119 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
120 03415a1a 2019-06-02 stsp }
121 03415a1a 2019-06-02 stsp
122 f6cae3ed 2020-09-13 naddy make_test_tree()
123 0e673013 2019-01-02 stsp {
124 0e673013 2019-01-02 stsp repo="$1"
125 0e673013 2019-01-02 stsp
126 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
127 0e673013 2019-01-02 stsp echo beta > $repo/beta
128 0e673013 2019-01-02 stsp mkdir $repo/gamma
129 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
130 0e673013 2019-01-02 stsp mkdir $repo/epsilon
131 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
132 0e673013 2019-01-02 stsp }
133 0e673013 2019-01-02 stsp
134 f6cae3ed 2020-09-13 naddy make_single_file_repo()
135 e7303626 2020-05-14 stsp {
136 e7303626 2020-05-14 stsp repo="$1"
137 e7303626 2020-05-14 stsp file="$2"
138 e7303626 2020-05-14 stsp
139 e7303626 2020-05-14 stsp mkdir $repo
140 e7303626 2020-05-14 stsp git_init $repo
141 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
142 e7303626 2020-05-14 stsp (cd $repo && git add .)
143 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
144 e7303626 2020-05-14 stsp }
145 e7303626 2020-05-14 stsp
146 f6cae3ed 2020-09-13 naddy get_loose_object_path()
147 e7303626 2020-05-14 stsp {
148 e7303626 2020-05-14 stsp local repo="$1"
149 e7303626 2020-05-14 stsp local id="$2"
150 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
151 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
152 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
153 e7303626 2020-05-14 stsp }
154 e7303626 2020-05-14 stsp
155 f6cae3ed 2020-09-13 naddy get_blob_id()
156 3ce1b845 2019-07-15 stsp {
157 3ce1b845 2019-07-15 stsp repo="$1"
158 3ce1b845 2019-07-15 stsp tree_path="$2"
159 3ce1b845 2019-07-15 stsp filename="$3"
160 3ce1b845 2019-07-15 stsp
161 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
162 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
163 3ce1b845 2019-07-15 stsp }
164 3ce1b845 2019-07-15 stsp
165 f6cae3ed 2020-09-13 naddy test_init()
166 0e673013 2019-01-02 stsp {
167 0e673013 2019-01-02 stsp local testname="$1"
168 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
169 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
170 0e673013 2019-01-02 stsp echo "No test name provided" >&2
171 0e673013 2019-01-02 stsp return 1
172 0e673013 2019-01-02 stsp fi
173 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
174 0e673013 2019-01-02 stsp mkdir $testroot/repo
175 0e673013 2019-01-02 stsp git_init $testroot/repo
176 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
177 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
178 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
179 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
180 4a1ddfc2 2019-01-12 stsp fi
181 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
182 0e673013 2019-01-02 stsp echo "$testroot"
183 0e673013 2019-01-02 stsp }
184 0e673013 2019-01-02 stsp
185 f6cae3ed 2020-09-13 naddy test_cleanup()
186 0e673013 2019-01-02 stsp {
187 0e673013 2019-01-02 stsp local testroot="$1"
188 fe7842f5 2019-07-14 stsp
189 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
190 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
191 fe7842f5 2019-07-14 stsp ret="$?"
192 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
193 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
194 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
195 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
196 fe7842f5 2019-07-14 stsp return 1
197 fe7842f5 2019-07-14 stsp fi
198 fe7842f5 2019-07-14 stsp
199 0e673013 2019-01-02 stsp rm -rf "$testroot"
200 0e673013 2019-01-02 stsp }
201 0e673013 2019-01-02 stsp
202 f6cae3ed 2020-09-13 naddy test_parseargs()
203 7fb414ae 2020-08-08 stsp {
204 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
205 6c8da0c6 2020-10-03 naddy case $flag in
206 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
207 6c8da0c6 2020-10-03 naddy ;;
208 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
209 6c8da0c6 2020-10-03 naddy ;;
210 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
211 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
212 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
213 6c8da0c6 2020-10-03 naddy exit 2
214 6c8da0c6 2020-10-03 naddy ;;
215 7fb414ae 2020-08-08 stsp esac
216 7fb414ae 2020-08-08 stsp done
217 6c8da0c6 2020-10-03 naddy } >&2
218 7fb414ae 2020-08-08 stsp
219 f6cae3ed 2020-09-13 naddy run_test()
220 0e673013 2019-01-02 stsp {
221 0e673013 2019-01-02 stsp testfunc="$1"
222 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
223 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
224 7fb414ae 2020-08-08 stsp fi
225 0e673013 2019-01-02 stsp $testfunc
226 0e673013 2019-01-02 stsp }
227 0e673013 2019-01-02 stsp
228 f6cae3ed 2020-09-13 naddy test_done()
229 0e673013 2019-01-02 stsp {
230 0e673013 2019-01-02 stsp local testroot="$1"
231 0e673013 2019-01-02 stsp local result="$2"
232 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
233 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
234 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
235 7fb414ae 2020-08-08 stsp echo "ok"
236 7fb414ae 2020-08-08 stsp fi
237 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
238 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
239 3941b73a 2019-05-14 stsp echo "$result"
240 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
241 0e673013 2019-01-02 stsp else
242 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
243 0e673013 2019-01-02 stsp fi
244 0e673013 2019-01-02 stsp }